searchNodes=[{"doc":"Snap is split into 3 main components:Snap.Cluster - clusters are wrappers around the Elasticsearch HTTP API. We can use this to perform low-level HTTP requests.Snap.Bulk - a convenience wrapper around bulk operations, using Stream to stream actions (such as Snap.Bulk.Action.Create) to be performed against the Snap.Cluster.Snap.Indexes - a convenience wrapper around the Elasticsearch indexes APIs, allowing the creation, deleting and aliasing of indexes, along with hotswap functionality to bulk load documents into an aliased index, switching to it atomically.Additionally, there are other supporting modules:Snap.Auth - defines how an HTTP request is modified to include authentication headers. Snap.Auth.Plain implements HTTP Basic Auth.Set upSnap.Cluster is a wrapped around an Elasticsearch cluster. We can define it like so:defmodule MyApp.Cluster do use Snap.Cluster, otp_app: :my_app endThe configuration for the cluster can be defined in your config:config :my_app, MyApp.Cluster, url: &quot;http://localhost:9200&quot;, username: &quot;username&quot;, password: &quot;password&quot;Or you can load it dynamically by implementing Snap.Cluster.init/1.Each cluster defines start_link/1 which must be invoked before using the cluster and optionally accepts an explicit config. It creates the supervision tree, including the connection pool.Include it in your application:def start(_type, _args) do children = [ {MyApp.Cluster, []} ] opts = [strategy: :one_for_one, name: MyApp.Supervisor] Supervisor.start_link(children, opts) endConfigThe following configuration options are supported:url - the URL of the Elasticsearch HTTP endpoint (required)username - the username used to access the clusterpassword - the password used to access the clusterauth - the auth module used to configure the HTTP authentication headers (defaults to Snap.Auth.Plain)pool_size - the maximum size of the HTTP connection pool (defaults to 5)telemetry_prefix - the prefix of the telemetry events (default to [:my_app, :snap])TelemetrySnap supports sending Telemetry events on each HTTP request. It sends one event per query, of the name [:my_app, :snap, :request].The telemetry event has the following measurements:response_time - how long the request took to returndecode_time - how long the response took to decode into a map or exceptiontotal_time - how long everything took in totalIn addition, the metadata contains a map of:method - the HTTP method usedpath - the path requestedheaders - a list of the headers sentbody - the body sentresult - the result returned to the user","ref":"Snap.html","title":"Snap","type":"module"},{"doc":"Supports streaming bulk operations against a Snap.Cluster.","ref":"Snap.Bulk.html","title":"Snap.Bulk","type":"module"},{"doc":"Performs a bulk operation.Takes an Enumerable of action structs, where each struct is one of:Snap.Bulk.Action.CreateSnap.Bulk.Action.IndexSnap.Bulk.Action.UpdateSnap.Bulk.Action.Deleteactions = [ %Snap.Bulk.Action.Create{_id: 1, doc: %{foo: &quot;bar&quot;}}, %Snap.Bulk.Action.Create{_id: 2, doc: %{foo: &quot;bar&quot;}}, %Snap.Bulk.Action.Create{_id: 3, doc: %{foo: &quot;bar&quot;}} ] actions |&gt; Snap.Bulk.perform(Cluster, &quot;index&quot;)It chunks the Enumerable into pages, and pauses between pages for Elasticsearch to catch up. Uses Stream under the hood, so you can lazily feed it a stream of actions, such as out of an Ecto.Repo to bulk load documents from an SQL database.If no errors occur on any page it returns :ok. If any errors occur, on any page, it returns {:error, %Snap.BulkError{}}, containing a list of the errors. It will continue to the end of the stream, even if errors occur.Options:page_size - defines the size of each page, defaulting to 5000 actions.page_wait - defines wait period between pages in ms, defaulting to 15000ms.max_errors - aborts when the number of errors returned exceedes this count (defaults to nil, which will run to the end)Any other options, such as pipeline: &quot;foo&quot; are passed through as query parameters to the Bulk API endpoint.","ref":"Snap.Bulk.html#perform/4","title":"Snap.Bulk.perform/4","type":"function"},{"doc":"Defines a cluster.A cluster maps to an Elasticsearch endpoint.When used, the cluster expects :otp_app as an option. The :otp_app should point to an OTP application that has the cluster configuration. For example, this cluster:defmodule MyApp.Cluster do use Snap.Cluster, otp_app: :my_app endCan be configured with:config :my_app, MyApp.Cluster, url: &quot;http://localhost:9200&quot;, username: &quot;username&quot;, password: &quot;password&quot;, pool_size: 10","ref":"Snap.Cluster.html","title":"Snap.Cluster","type":"behaviour"},{"doc":"Returns the config in use by this cluster.","ref":"Snap.Cluster.html#c:config/0","title":"Snap.Cluster.config/0","type":"callback"},{"doc":"Sends a DELETE request.Returns either:{:ok, response} - where response is a map representing the parsed JSON response.{:error, error} - where the error can be a struct of either:Snap.ExceptionMint.TransportErrorMint.HTTPErrorJason.DecodeError","ref":"Snap.Cluster.html#c:delete/4","title":"Snap.Cluster.delete/4","type":"callback"},{"doc":"Sends a GET request.Returns either:{:ok, response} - where response is a map representing the parsed JSON response.{:error, error} - where the error can be a struct of either:Snap.ExceptionMint.TransportErrorMint.HTTPErrorJason.DecodeError","ref":"Snap.Cluster.html#c:get/4","title":"Snap.Cluster.get/4","type":"callback"},{"doc":"Sets up the config for the cluster.Override this to dynamically load a config from somewhere other than your application config.","ref":"Snap.Cluster.html#c:init/1","title":"Snap.Cluster.init/1","type":"callback"},{"doc":"Sends a POST request.Returns either:{:ok, response} - where response is a map representing the parsed JSON response.{:error, error} - where the error can be a struct of either:Snap.ExceptionMint.TransportErrorMint.HTTPErrorJason.DecodeError","ref":"Snap.Cluster.html#c:post/5","title":"Snap.Cluster.post/5","type":"callback"},{"doc":"Sends a PUT request.Returns either:{:ok, response} - where response is a map representing the parsed JSON response.{:error, error} - where the error can be a struct of either:Snap.ExceptionMint.TransportErrorMint.HTTPErrorJason.DecodeError","ref":"Snap.Cluster.html#c:put/5","title":"Snap.Cluster.put/5","type":"callback"},{"doc":"The body of the HTTP request","ref":"Snap.Cluster.html#t:body/0","title":"Snap.Cluster.body/0","type":"type"},{"doc":"An error from an HTTP operation","ref":"Snap.Cluster.html#t:error/0","title":"Snap.Cluster.error/0","type":"type"},{"doc":"Any additional HTTP headers sent with the request","ref":"Snap.Cluster.html#t:headers/0","title":"Snap.Cluster.headers/0","type":"type"},{"doc":"Options passed through to the request","ref":"Snap.Cluster.html#t:opts/0","title":"Snap.Cluster.opts/0","type":"type"},{"doc":"The query params, which will be appended to the path","ref":"Snap.Cluster.html#t:params/0","title":"Snap.Cluster.params/0","type":"type"},{"doc":"The path of the HTTP endpoint","ref":"Snap.Cluster.html#t:path/0","title":"Snap.Cluster.path/0","type":"type"},{"doc":"The result from an HTTP operation","ref":"Snap.Cluster.html#t:result/0","title":"Snap.Cluster.result/0","type":"type"},{"doc":"A successful results from an HTTP operation","ref":"Snap.Cluster.html#t:success/0","title":"Snap.Cluster.success/0","type":"type"},{"doc":"Helper functions around index management.","ref":"Snap.Indexes.html","title":"Snap.Indexes","type":"module"},{"doc":"Creates an alias for a versioned index, removing any existing aliases.","ref":"Snap.Indexes.html#alias/4","title":"Snap.Indexes.alias/4","type":"function"},{"doc":"Deletes older timestamped indexes.","ref":"Snap.Indexes.html#cleanup/4","title":"Snap.Indexes.cleanup/4","type":"function"},{"doc":"Creates an index.","ref":"Snap.Indexes.html#create/4","title":"Snap.Indexes.create/4","type":"function"},{"doc":"Deletes an index.","ref":"Snap.Indexes.html#delete/3","title":"Snap.Indexes.delete/3","type":"function"},{"doc":"Creates and loads a new index, switching the alias to it with zero-downtime.Takes an Enumerable of Snap.Bulk actions, and builds a new index from it. Refreshes it, updates the alias to it, and cleans up the old indexes, leaving the previous one behind.May return Snap.Cluster.error/0 or a Snap.BulkError containing a list of failed bulk actions.","ref":"Snap.Indexes.html#hotswap/5","title":"Snap.Indexes.hotswap/5","type":"function"},{"doc":"Lists all the indexes in the cluster.","ref":"Snap.Indexes.html#list/2","title":"Snap.Indexes.list/2","type":"function"},{"doc":"Lists all the timestamp versioned indexes starting with the prefix.","ref":"Snap.Indexes.html#list_starting_with/3","title":"Snap.Indexes.list_starting_with/3","type":"function"},{"doc":"Refreshes an index.","ref":"Snap.Indexes.html#refresh/3","title":"Snap.Indexes.refresh/3","type":"function"},{"doc":"Defines how HTTP request is transformed to add authentication.","ref":"Snap.Auth.html","title":"Snap.Auth","type":"behaviour"},{"doc":"Modifies an HTTP request to include authentication details","ref":"Snap.Auth.html#c:sign/5","title":"Snap.Auth.sign/5","type":"callback"},{"doc":"","ref":"Snap.Auth.html#t:body/0","title":"Snap.Auth.body/0","type":"type"},{"doc":"","ref":"Snap.Auth.html#t:config/0","title":"Snap.Auth.config/0","type":"type"},{"doc":"","ref":"Snap.Auth.html#t:headers/0","title":"Snap.Auth.headers/0","type":"type"},{"doc":"","ref":"Snap.Auth.html#t:method/0","title":"Snap.Auth.method/0","type":"type"},{"doc":"","ref":"Snap.Auth.html#t:opts/0","title":"Snap.Auth.opts/0","type":"type"},{"doc":"","ref":"Snap.Auth.html#t:response/0","title":"Snap.Auth.response/0","type":"type"},{"doc":"","ref":"Snap.Auth.html#t:url/0","title":"Snap.Auth.url/0","type":"type"},{"doc":"Implements HTTP Basic Auth, if necessary.If the cluster config defines a username and password, an Authorization: Basic header is added to the request.config :my_app, MyApp.Cluster, url: &quot;http://localhost:9200&quot;, username: &quot;foo&quot;, password: &quot;barOr you can define a username and password in the URL itself:config :my_app, MyApp.Cluster, url: &quot;http://username:password@localhost:9200&quot;If no username or password is defined, no Authorization header is added, making it suitable for local development.","ref":"Snap.Auth.Plain.html","title":"Snap.Auth.Plain","type":"module"},{"doc":"Callback implementation for Snap.Auth.sign/5.","ref":"Snap.Auth.Plain.html#sign/5","title":"Snap.Auth.Plain.sign/5","type":"function"},{"doc":"Represents a create step in a Snap.Bulk operation","ref":"Snap.Bulk.Action.Create.html","title":"Snap.Bulk.Action.Create","type":"module"},{"doc":"","ref":"Snap.Bulk.Action.Create.html#t:t/0","title":"Snap.Bulk.Action.Create.t/0","type":"type"},{"doc":"Represents a delete step in a Snap.Bulk operation","ref":"Snap.Bulk.Action.Delete.html","title":"Snap.Bulk.Action.Delete","type":"module"},{"doc":"","ref":"Snap.Bulk.Action.Delete.html#t:t/0","title":"Snap.Bulk.Action.Delete.t/0","type":"type"},{"doc":"Represents an index step in a Snap.Bulk operation","ref":"Snap.Bulk.Action.Index.html","title":"Snap.Bulk.Action.Index","type":"module"},{"doc":"","ref":"Snap.Bulk.Action.Index.html#t:t/0","title":"Snap.Bulk.Action.Index.t/0","type":"type"},{"doc":"Represents an update step in a Snap.Bulk operation","ref":"Snap.Bulk.Action.Update.html","title":"Snap.Bulk.Action.Update","type":"module"},{"doc":"","ref":"Snap.Bulk.Action.Update.html#t:t/0","title":"Snap.Bulk.Action.Update.t/0","type":"type"},{"doc":"Represents a list of errors, collected from a Snap.Bulk operation.","ref":"Snap.BulkError.html","title":"Snap.BulkError","type":"exception"},{"doc":"","ref":"Snap.BulkError.html#t:t/0","title":"Snap.BulkError.t/0","type":"type"},{"doc":"Represents an Elasticsearch exception raised while executing a query.","ref":"Snap.Exception.html","title":"Snap.Exception","type":"exception"},{"doc":"","ref":"Snap.Exception.html#exception_from_response/1","title":"Snap.Exception.exception_from_response/1","type":"function"},{"doc":"","ref":"Snap.Exception.html#t:t/0","title":"Snap.Exception.t/0","type":"type"}]